// STACK SPREADER 1.0 (2/29/12)
// by n.reeves (nate.reeves@gmail.com // nkurence.com)
//
// Takes a stack of images and spreads them along a selectable axis and direction
//

// open a dialog window to prompt user for spread direction
var fileDialog = new Window('dialog', 'Please Choose a Direction:');
fileDialog.bounds = [100, 100, 390, 230];
dTop=fileDialog.add('button', [10, 10, 280, 30], 'Top',{name:'Top'});
dBottom=fileDialog.add('button', [10, 40, 280, 60], 'Bottom',{name:'Bottom'});
dLeft=fileDialog.add('button', [10, 70, 280, 90], 'Left',{name:'Left'});
dRight=fileDialog.add('button', [10, 100, 280, 120], 'Right',{name:'Right'});
dTop.onClick=function() {fileDialog.close(1);};
dBottom.onClick=function() {fileDialog.close(2);};
dLeft.onClick=function() {fileDialog.close(3);};
dRight.onClick=function() {fileDialog.close(4);};
var result = fileDialog.show();
if(result == 1){var stackDir = "T";}
if(result == 2){var stackDir = "B";}
if(result == 3){var stackDir = "L";}
if(result == 4){var stackDir = "R";}

// find out the pixel width and height of the canvas
imgHeight = app.activeDocument.height;
imgWidth = app.activeDocument.width;
// find out how many layers there are in the stack
imgFrames = app.activeDocument.layers.length;
// set the units to pixels
preferences.rulerUnits = Units.PIXELS;
// set a variable for how many times to run the resize/move function, -1 to ignore the first layer
fSteps = imgFrames - 1;
totalHeight = imgHeight * fSteps;
totalWidth = imgWidth * fSteps;

if(app.documents.length > 0){
stackArranger(imgHeight, imgWidth, stackDir, totalHeight, totalWidth); //call the function and tell it about the document and direction
}
function stackArranger(hDis, wDis, sDir, tHeight, tWidth){
		if (sDir == "B" || sDir == "b"){ // if user chose Bottom, extend canvas
			var idCnvS = charIDToTypeID( "CnvS" );
				var desc190 = new ActionDescriptor();
				var idRltv = charIDToTypeID( "Rltv" );
				desc190.putBoolean( idRltv, true );
				var idHght = charIDToTypeID( "Hght" );
				var idPxl = charIDToTypeID( "#Pxl" );
				desc190.putUnitDouble( idHght, idPxl, tHeight );
				var idVrtc = charIDToTypeID( "Vrtc" );
				var idVrtL = charIDToTypeID( "VrtL" );
				var idTop = charIDToTypeID( "Top " );
				desc190.putEnumerated( idVrtc, idVrtL, idTop );
			executeAction( idCnvS, desc190, DialogModes.NO );
		} else if (sDir == "T" || sDir == "t"){ // if user chose Top, extend canvas 
			var idCnvS = charIDToTypeID( "CnvS" );
				var desc187 = new ActionDescriptor();
				var idRltv = charIDToTypeID( "Rltv" );
				desc187.putBoolean( idRltv, true );
				var idHght = charIDToTypeID( "Hght" );
				var idPxl = charIDToTypeID( "#Pxl" );
				desc187.putUnitDouble( idHght, idPxl, tHeight );
				var idVrtc = charIDToTypeID( "Vrtc" );
				var idVrtL = charIDToTypeID( "VrtL" );
				var idBttm = charIDToTypeID( "Bttm" );
				desc187.putEnumerated( idVrtc, idVrtL, idBttm );
			executeAction( idCnvS, desc187, DialogModes.NO );
		} else if (sDir == "L" || sDir == "l"){ // if user chose Left, extend canvas
			var idCnvS = charIDToTypeID( "CnvS" );
				var desc188 = new ActionDescriptor();
				var idRltv = charIDToTypeID( "Rltv" );
				desc188.putBoolean( idRltv, true );
				var idWdth = charIDToTypeID( "Wdth" );
				var idPxl = charIDToTypeID( "#Pxl" );
				desc188.putUnitDouble( idWdth, idPxl, tWidth );
				var idHrzn = charIDToTypeID( "Hrzn" );
				var idHrzL = charIDToTypeID( "HrzL" );
				var idRght = charIDToTypeID( "Rght" );
				desc188.putEnumerated( idHrzn, idHrzL, idRght );
			executeAction( idCnvS, desc188, DialogModes.NO );
		} else if (sDir == "R" || sDir == "r"){ // if user chose Right, extend canvas
			var idCnvS = charIDToTypeID( "CnvS" );
				var desc191 = new ActionDescriptor();
				var idRltv = charIDToTypeID( "Rltv" );
				desc191.putBoolean( idRltv, true );
				var idWdth = charIDToTypeID( "Wdth" );
				var idPxl = charIDToTypeID( "#Pxl" );
				desc191.putUnitDouble( idWdth, idPxl, tWidth );
				var idHrzn = charIDToTypeID( "Hrzn" );
				var idHrzL = charIDToTypeID( "HrzL" );
				var idLeft = charIDToTypeID( "Left" );
				desc191.putEnumerated( idHrzn, idHrzL, idLeft );
			executeAction( idCnvS, desc191, DialogModes.NO );
		}
	for (var i = 0; i < fSteps; i++){ // for every layer in the document run the function
		// after canvas is resized, select the next layer down in the stack
		var idslct = charIDToTypeID( "slct" );
			var desc61 = new ActionDescriptor();
			var idnull = charIDToTypeID( "null" );
				var ref31 = new ActionReference();
				var idLyr = charIDToTypeID( "Lyr " );
				var idOrdn = charIDToTypeID( "Ordn" );
				var idBckw = charIDToTypeID( "Bckw" );
				ref31.putEnumerated( idLyr, idOrdn, idBckw );
			desc61.putReference( idnull, ref31 );
			var idMkVs = charIDToTypeID( "MkVs" );
			desc61.putBoolean( idMkVs, false );
		executeAction( idslct, desc61, DialogModes.NO );

		// after the next layer is selected, we move it equal to the stack width or height multiplied against the current layer index
		var currentLyr = i + 1; // layer index + 1 = current layer (since we dont move the first layer)
		if (sDir == "B" || sDir == "b"){
			var lyrMove = imgHeight*currentLyr;
			app.activeDocument.layers[currentLyr].translate(0,lyrMove);}
		else if (sDir == "T" || sDir == "t"){
			var lyrMove = imgHeight*currentLyr;
			app.activeDocument.layers[currentLyr].translate(0,(lyrMove*= -1));} // *= -1 to reverse the direction
		else if (sDir == "L" || sDir == "l"){
			var lyrMove = imgWidth*currentLyr;
			app.activeDocument.layers[currentLyr].translate((lyrMove*= -1),0);}
		else if (sDir == "R" || sDir == "r"){
			var lyrMove = imgWidth*currentLyr;
			app.activeDocument.layers[currentLyr].translate(lyrMove,0);}
	}
}